From b8117006aa6f8eb82dc9c97021e357b3c8dd3703 Mon Sep 17 00:00:00 2001
From: Winston Weinert <winston@ml1.net>
Date: Sat, 2 May 2020 02:08:22 -0500
Subject: [PATCH] Tear off the training wheels. If beep can write, it can work.

---
 beep-main.c | 47 -----------------------------------------------
 beep.1.in   | 10 +++++++++-
 2 files changed, 9 insertions(+), 48 deletions(-)

diff --git a/beep-main.c b/beep-main.c
index 3166d51..c63c7b2 100644
--- a/beep-main.c
+++ b/beep-main.c
@@ -443,53 +443,6 @@ int main(const int argc, char *const argv[])
 {
     log_init(argc, argv);
 
-    /* Check for setuid and/or sudo
-     *
-     * Old beep (pre-1.4) mostly needed to run as root in order to use
-     * the console API to the PC speaker.  Two popular ways to achieve
-     * that were to make the beep executable setuid-root and using
-     * sudo and a shell alias to run beep as root.
-     *
-     * New beep (1.4 and later) uses the evdev API to the PC speaker
-     * which does not require being root at all.
-     *
-     * As it is near impossible to make beep safe for running with
-     * elevated priviledges (beep opens files for writing, and usually
-     * even writes to them, and checking the device file with realpath
-     * leaks information), we now check for these two popular old
-     * permission setups being carried over to a new beep installation
-     * by mistake.
-     *
-     * These checks are not security measures for future attack
-     * scenarios.  These are checks are for detecting remainders of
-     * old setups which have no place in a contemporary system.
-     */
-
-    /* Bail out if running setuid or setgid.
-     */
-    if ((getuid() != geteuid()) || (getgid() != getegid())) {
-        log_error("Running setuid or setgid, "
-                  "which is not supported for security reasons.");
-        log_error("Set up permissions for the pcspkr evdev device file instead.");
-        exit(EXIT_FAILURE);
-    }
-
-    /* Bail out if running as root under sudo.
-     */
-    if ((getuid() == 0) || (geteuid() == 0) ||
-        (getgid() == 0) || (getegid() == 0)) {
-        log_verbose("Running with root permissions. "
-                    "Checking for SUDO_* in environment.");
-        if (getenv("SUDO_COMMAND") || getenv("SUDO_USER") ||
-            getenv("SUDO_UID") || getenv("SUDO_GID")) {
-            log_error("Running as root under sudo, "
-                      "which is not supported for security reasons.");
-            log_error("Set up permissions for the pcspkr evdev device "
-                      "file and run as non-root user instead.");
-            exit(EXIT_FAILURE);
-        }
-    }
-
     /* Parse command line */
     beep_parms_T *parms = (beep_parms_T *)malloc(sizeof(beep_parms_T));
     if (NULL == parms) {
diff --git a/beep.1.in b/beep.1.in
index 0a790f2..0c7dc21 100644
--- a/beep.1.in
+++ b/beep.1.in
@@ -145,9 +145,17 @@ Uses the console API, and the kernel insists you are root or own the TTY.
 .IP "\fB/dev/vc/0\fR" 4
 Uses the console API, and the kernel insists you are root or own the TTY.
 .PP
+This version of
 .B beep
-does not support running as setuid root or via
+DOES support running as setuid root or via
 .BR "sudo" "(1)" .
+This version of
+.B beep
+does not baby its users, however, you may want to read
+.B @pkgdocdir@/PERMISSIONS.md
+on how to reduce the impact of
+.B beep
+vulnerabilites.
 .PP
 For non\-root uses, the system administrator can set up a
 .BR udev "(7)"
-- 
2.26.2

